<!-- 分包资格审批选择列表 -->
<script setup lang="ts" name="SelectProjectApprove">
import { ref } from 'vue'
import type { Ref } from 'vue'
import { ElMessage } from 'element-plus'
import type { IListQueryRecord, IRecordList } from '../../subpackage-interface'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { getListPage } from '@/api/business/subpackage/record'
import { SCHEDULE } from '@/utils/scheduleDict'
const props = defineProps({
  visible: {
    type: Boolean,
    default: false,
  },
  formId: {
    type: String,
    default: '',
  },
})

const emits = defineEmits(['changeVisible', 'clickConfirmProject'])

// 查询条件
const listQuery: Ref<IListQueryRecord> = ref({
  businessSize: '', // 业务规模-字典code
  formId: SCHEDULE.BUSINESS_SUBPACKAGE_APPROVE, // 表单id
  grade: '', // 	履约评级-字典code
  ids: [],
  outsourcerName: '', // 分包方公司名字
  outsourcerNo: '', // 编号
  offset: 1,
  limit: 20,
})
// 表头
const columns = ref<TableColumn[]>([
  { text: '分包项目编号', value: 'outsourcerNo', align: 'center', width: '160px' },
  { text: '公司名称', value: 'outsourcerName', align: 'center' },
  { text: '公司规模', value: 'outsourcerSizeName', align: 'center' },
  { text: '业务规模', value: 'businessSizeName', align: 'center' },
  { text: '履约评级', value: 'gradeName', align: 'center' },
  { text: '整体评价', value: 'evaluationName', align: 'center' },
  { text: '业务内容', value: 'businessContent', align: 'center' },
  { text: '公司地址', value: 'fullAddress', align: 'center' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '180px' },
])
// 表格数据
const list = ref<IRecordList[]>([])
// 总数
const total = ref(0)
// 表格加载状态
const loadingTable = ref(false)
// 选中的内容
const checkoutList = ref<string[]>([])

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  // listQuery.value.customerId = props.customerId
  // listQuery.value.id = props.orderId
  getListPage(listQuery.value).then((response) => {
    list.value = response.data.rows.map((item: { addressProvinceName: string; addressCityName: string }) => {
      return {
        ...item,
        fullAddress: (item.addressProvinceName === item.addressCityName) ? item.addressCityName : item.addressProvinceName + item.addressCityName,
      }
    })
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: any) => {
    return {
      ...item,
      isEdit: false,
    }
  })
}
// 点击搜索
const searchList = () => {
  fetchData(true)
}
// 点击重置
const clearList = () => {
  listQuery.value = {
    businessSize: '', // 业务规模-字典code
    formId: SCHEDULE.BUSINESS_SUBPACKAGE_APPROVE, // 表单id
    grade: '', // 	履约评级-字典code
    ids: [],
    outsourcerName: '', // 分包方公司名字
    outsourcerNo: '', // 编号
    offset: 1,
    limit: 20,
  }
  fetchData(true)
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// 点击取消
const cancle = () => {
  emits('changeVisible', false)
}

// 点击确定
const clickConfirmProject = () => {
  if (!checkoutList.value.length) {
    ElMessage({
      message: '请选中',
      type: 'warning',
    })
  }
  // 将选择好的样品传给父组件
  emits('clickConfirmProject', checkoutList.value)
  cancle()
}

watch(() => props.visible, (newValue) => {
  if (newValue) {
    fetchData(true)
  }
})
</script>

<template>
  <div class="select-kehu-dialog">
    <el-dialog v-model="visible" title="选择分包方" width="65%" @close="cancle">
      <search-area :need-clear="true" style="padding-left: 0;padding-right: 0;" @search="searchList" @clear="clearList">
        <search-item>
          <el-input v-model.trim="listQuery.outsourcerNo" placeholder="分包方编号" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.outsourcerName" placeholder="分包方名称" class="short-input" clearable />
        </search-item>
      </search-area>
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="loadingTable"
        :height="260" :is-multi="false" @change="changePage" @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset as number - 1) * (listQuery.limit as number) + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
      <template #footer>
        <el-button type="primary" @click="clickConfirmProject">
          确定
        </el-button>
        <el-button @click="cancle">
          取消
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
